git-submodule.sh: clarify the "should we die now" logic
[git/jrn.git] / git-submodule.sh
blob066d6b57160ab93f65bf5893cc8d355fbf237982
1 #!/bin/sh
3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
15 OPTIONS_SPEC=
16 . git-sh-setup
17 . git-parse-remote
18 require_work_tree
20 command=
21 branch=
22 force=
23 reference=
24 cached=
25 recursive=
26 init=
27 files=
28 nofetch=
29 update=
30 prefix=
32 # Resolve relative url by appending to parent's url
33 resolve_relative_url ()
35 remote=$(get_default_remote)
36 remoteurl=$(git config "remote.$remote.url") ||
37 die "remote ($remote) does not have a url defined in .git/config"
38 url="$1"
39 remoteurl=${remoteurl%/}
40 sep=/
41 while test -n "$url"
43 case "$url" in
44 ../*)
45 url="${url#../}"
46 case "$remoteurl" in
47 */*)
48 remoteurl="${remoteurl%/*}"
50 *:*)
51 remoteurl="${remoteurl%:*}"
52 sep=:
55 die "cannot strip one component off url '$remoteurl'"
57 esac
59 ./*)
60 url="${url#./}"
63 break;;
64 esac
65 done
66 echo "$remoteurl$sep${url%/}"
70 # Get submodule info for registered submodules
71 # $@ = path to limit submodule list
73 module_list()
75 git ls-files --error-unmatch --stage -- "$@" |
76 perl -e '
77 my %unmerged = ();
78 my ($null_sha1) = ("0" x 40);
79 while (<STDIN>) {
80 chomp;
81 my ($mode, $sha1, $stage, $path) =
82 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
83 next unless $mode eq "160000";
84 if ($stage ne "0") {
85 if (!$unmerged{$path}++) {
86 print "$mode $null_sha1 U\t$path\n";
88 next;
90 print "$_\n";
96 # Map submodule path to submodule name
98 # $1 = path
100 module_name()
102 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
103 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
104 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
105 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
106 test -z "$name" &&
107 die "No submodule mapping found in .gitmodules for path '$path'"
108 echo "$name"
112 # Clone a submodule
114 # Prior to calling, cmd_update checks that a possibly existing
115 # path is not a git repository.
116 # Likewise, cmd_add checks that path does not exist at all,
117 # since it is the location of a new submodule.
119 module_clone()
121 path=$1
122 url=$2
123 reference="$3"
125 if test -n "$reference"
126 then
127 git-clone "$reference" -n "$url" "$path"
128 else
129 git-clone -n "$url" "$path"
130 fi ||
131 die "Clone of '$url' into submodule path '$path' failed"
135 # Add a new submodule to the working tree, .gitmodules and the index
137 # $@ = repo path
139 # optional branch is stored in global branch variable
141 cmd_add()
143 # parse $args after "submodule ... add".
144 while test $# -ne 0
146 case "$1" in
147 -b | --branch)
148 case "$2" in '') usage ;; esac
149 branch=$2
150 shift
152 -f | --force)
153 force=$1
155 -q|--quiet)
156 GIT_QUIET=1
158 --reference)
159 case "$2" in '') usage ;; esac
160 reference="--reference=$2"
161 shift
163 --reference=*)
164 reference="$1"
165 shift
168 shift
169 break
172 usage
175 break
177 esac
178 shift
179 done
181 repo=$1
182 path=$2
184 if test -z "$path"; then
185 path=$(echo "$repo" |
186 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
189 if test -z "$repo" -o -z "$path"; then
190 usage
193 # assure repo is absolute or relative to parent
194 case "$repo" in
195 ./*|../*)
196 # dereference source url relative to parent's url
197 realrepo=$(resolve_relative_url "$repo") || exit
199 *:*|/*)
200 # absolute url
201 realrepo=$repo
204 die "repo URL: '$repo' must be absolute or begin with ./|../"
206 esac
208 # normalize path:
209 # multiple //; leading ./; /./; /../; trailing /
210 path=$(printf '%s/\n' "$path" |
211 sed -e '
212 s|//*|/|g
213 s|^\(\./\)*||
214 s|/\./|/|g
215 :start
216 s|\([^/]*\)/\.\./||
217 tstart
218 s|/*$||
220 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
221 die "'$path' already exists in the index"
223 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
224 then
225 echo >&2 "The following path is ignored by one of your .gitignore files:" &&
226 echo >&2 $path &&
227 echo >&2 "Use -f if you really want to add it."
228 exit 1
231 # perhaps the path exists and is already a git repo, else clone it
232 if test -e "$path"
233 then
234 if test -d "$path"/.git -o -f "$path"/.git
235 then
236 echo "Adding existing repo at '$path' to the index"
237 else
238 die "'$path' already exists and is not a valid git repo"
241 case "$repo" in
242 ./*|../*)
243 url=$(resolve_relative_url "$repo") || exit
246 url="$repo"
248 esac
249 git config submodule."$path".url "$url"
250 else
252 module_clone "$path" "$realrepo" "$reference" || exit
254 clear_local_git_env
255 cd "$path" &&
256 # ash fails to wordsplit ${branch:+-b "$branch"...}
257 case "$branch" in
258 '') git checkout -f -q ;;
259 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
260 esac
261 ) || die "Unable to checkout submodule '$path'"
264 git add $force "$path" ||
265 die "Failed to add submodule '$path'"
267 git config -f .gitmodules submodule."$path".path "$path" &&
268 git config -f .gitmodules submodule."$path".url "$repo" &&
269 git add --force .gitmodules ||
270 die "Failed to register submodule '$path'"
274 # Execute an arbitrary command sequence in each checked out
275 # submodule
277 # $@ = command to execute
279 cmd_foreach()
281 # parse $args after "submodule ... foreach".
282 while test $# -ne 0
284 case "$1" in
285 -q|--quiet)
286 GIT_QUIET=1
288 --recursive)
289 recursive=1
292 usage
295 break
297 esac
298 shift
299 done
301 toplevel=$(pwd)
303 module_list |
304 while read mode sha1 stage path
306 if test -e "$path"/.git
307 then
308 say "Entering '$prefix$path'"
309 name=$(module_name "$path")
311 prefix="$prefix$path/"
312 clear_local_git_env
313 cd "$path" &&
314 eval "$@" &&
315 if test -n "$recursive"
316 then
317 cmd_foreach "--recursive" "$@"
319 ) ||
320 die "Stopping at '$path'; script returned non-zero status."
322 done
326 # Register submodules in .git/config
328 # $@ = requested paths (default to all)
330 cmd_init()
332 # parse $args after "submodule ... init".
333 while test $# -ne 0
335 case "$1" in
336 -q|--quiet)
337 GIT_QUIET=1
340 shift
341 break
344 usage
347 break
349 esac
350 shift
351 done
353 module_list "$@" |
354 while read mode sha1 stage path
356 # Skip already registered paths
357 name=$(module_name "$path") || exit
358 url=$(git config submodule."$name".url)
359 test -z "$url" || continue
361 url=$(git config -f .gitmodules submodule."$name".url)
362 test -z "$url" &&
363 die "No url found for submodule path '$path' in .gitmodules"
365 # Possibly a url relative to parent
366 case "$url" in
367 ./*|../*)
368 url=$(resolve_relative_url "$url") || exit
370 esac
372 git config submodule."$name".url "$url" ||
373 die "Failed to register url for submodule path '$path'"
375 upd="$(git config -f .gitmodules submodule."$name".update)"
376 test -z "$upd" ||
377 git config submodule."$name".update "$upd" ||
378 die "Failed to register update mode for submodule path '$path'"
380 say "Submodule '$name' ($url) registered for path '$path'"
381 done
385 # Update each submodule path to correct revision, using clone and checkout as needed
387 # $@ = requested paths (default to all)
389 cmd_update()
391 # parse $args after "submodule ... update".
392 orig_flags=
393 while test $# -ne 0
395 case "$1" in
396 -q|--quiet)
397 GIT_QUIET=1
399 -i|--init)
400 init=1
402 -N|--no-fetch)
403 nofetch=1
405 -f|--force)
406 force=$1
408 -r|--rebase)
409 update="rebase"
411 --reference)
412 case "$2" in '') usage ;; esac
413 reference="--reference=$2"
414 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
415 shift
417 --reference=*)
418 reference="$1"
420 -m|--merge)
421 update="merge"
423 --recursive)
424 recursive=1
427 shift
428 break
431 usage
434 break
436 esac
437 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
438 shift
439 done
441 if test -n "$init"
442 then
443 cmd_init "--" "$@" || return
446 cloned_modules=
447 module_list "$@" | {
448 err=
449 while read mode sha1 stage path
451 if test "$stage" = U
452 then
453 echo >&2 "Skipping unmerged submodule $path"
454 continue
456 name=$(module_name "$path") || exit
457 url=$(git config submodule."$name".url)
458 update_module=$(git config submodule."$name".update)
459 if test -z "$url"
460 then
461 # Only mention uninitialized submodules when its
462 # path have been specified
463 test "$#" != "0" &&
464 say "Submodule path '$path' not initialized" &&
465 say "Maybe you want to use 'update --init'?"
466 continue
469 if ! test -d "$path"/.git -o -f "$path"/.git
470 then
471 module_clone "$path" "$url" "$reference"|| exit
472 cloned_modules="$cloned_modules;$name"
473 subsha1=
474 else
475 subsha1=$(clear_local_git_env; cd "$path" &&
476 git rev-parse --verify HEAD) ||
477 die "Unable to find current revision in submodule path '$path'"
480 if ! test -z "$update"
481 then
482 update_module=$update
485 if test "$subsha1" != "$sha1"
486 then
487 subforce=$force
488 # If we don't already have a -f flag and the submodule has never been checked out
489 if test -z "$subsha1" -a -z "$force"
490 then
491 subforce="-f"
494 if test -z "$nofetch"
495 then
496 # Run fetch only if $sha1 isn't present or it
497 # is not reachable from a ref.
498 (clear_local_git_env; cd "$path" &&
499 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
500 test -z "$rev") || git-fetch)) ||
501 die "Unable to fetch in submodule path '$path'"
504 # Is this something we just cloned?
505 case ";$cloned_modules;" in
506 *";$name;"*)
507 # then there is no local change to integrate
508 update_module= ;;
509 esac
511 must_die_on_failure=
512 case "$update_module" in
513 rebase)
514 command="git rebase"
515 action="rebase"
516 msg="rebased onto"
517 must_die_on_failure=yes
519 merge)
520 command="git merge"
521 action="merge"
522 msg="merged in"
523 must_die_on_failure=yes
526 command="git checkout $subforce -q"
527 action="checkout"
528 msg="checked out"
530 esac
532 if (clear_local_git_env; cd "$path" && $command "$sha1")
533 then
534 say "Submodule path '$path': $msg '$sha1'"
535 elif test -n "$must_die_on_failure"
536 then
537 die_with_status 2 "Unable to $action '$sha1' in submodule path '$path'"
538 else
539 err="${err};Failed to $action in submodule path '$path'"
540 continue
544 if test -n "$recursive"
545 then
546 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags")
547 res=$?
548 if test $res -gt 0
549 then
550 if test $res -eq 1
551 then
552 err="${err};Failed to recurse into submodule path '$path'"
553 continue
554 else
555 die_with_status $res "Failed to recurse into submodule path '$path'"
559 done
561 if test -n "$err"
562 then
563 OIFS=$IFS
564 IFS=';'
565 for e in $err
567 if test -n "$e"
568 then
569 echo >&2 "$e"
571 done
572 IFS=$OIFS
573 exit 1
578 set_name_rev () {
579 revname=$( (
580 clear_local_git_env
581 cd "$1" && {
582 git describe "$2" 2>/dev/null ||
583 git describe --tags "$2" 2>/dev/null ||
584 git describe --contains "$2" 2>/dev/null ||
585 git describe --all --always "$2"
588 test -z "$revname" || revname=" ($revname)"
591 # Show commit summary for submodules in index or working tree
593 # If '--cached' is given, show summary between index and given commit,
594 # or between working tree and given commit
596 # $@ = [commit (default 'HEAD'),] requested paths (default all)
598 cmd_summary() {
599 summary_limit=-1
600 for_status=
601 diff_cmd=diff-index
603 # parse $args after "submodule ... summary".
604 while test $# -ne 0
606 case "$1" in
607 --cached)
608 cached="$1"
610 --files)
611 files="$1"
613 --for-status)
614 for_status="$1"
616 -n|--summary-limit)
617 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
618 then
620 else
621 usage
623 shift
626 shift
627 break
630 usage
633 break
635 esac
636 shift
637 done
639 test $summary_limit = 0 && return
641 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
642 then
643 head=$rev
644 test $# = 0 || shift
645 elif test -z "$1" -o "$1" = "HEAD"
646 then
647 # before the first commit: compare with an empty tree
648 head=$(git hash-object -w -t tree --stdin </dev/null)
649 test -z "$1" || shift
650 else
651 head="HEAD"
654 if [ -n "$files" ]
655 then
656 test -n "$cached" &&
657 die "--cached cannot be used with --files"
658 diff_cmd=diff-files
659 head=
662 cd_to_toplevel
663 # Get modified modules cared by user
664 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
665 sane_egrep '^:([0-7]* )?160000' |
666 while read mod_src mod_dst sha1_src sha1_dst status name
668 # Always show modules deleted or type-changed (blob<->module)
669 test $status = D -o $status = T && echo "$name" && continue
670 # Also show added or modified modules which are checked out
671 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
672 echo "$name"
673 done
676 test -z "$modules" && return
678 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
679 sane_egrep '^:([0-7]* )?160000' |
680 cut -c2- |
681 while read mod_src mod_dst sha1_src sha1_dst status name
683 if test -z "$cached" &&
684 test $sha1_dst = 0000000000000000000000000000000000000000
685 then
686 case "$mod_dst" in
687 160000)
688 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
690 100644 | 100755 | 120000)
691 sha1_dst=$(git hash-object $name)
693 000000)
694 ;; # removed
696 # unexpected type
697 echo >&2 "unexpected mode $mod_dst"
698 continue ;;
699 esac
701 missing_src=
702 missing_dst=
704 test $mod_src = 160000 &&
705 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
706 missing_src=t
708 test $mod_dst = 160000 &&
709 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
710 missing_dst=t
712 total_commits=
713 case "$missing_src,$missing_dst" in
715 errmsg=" Warn: $name doesn't contain commit $sha1_src"
718 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
720 t,t)
721 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
724 errmsg=
725 total_commits=$(
726 if test $mod_src = 160000 -a $mod_dst = 160000
727 then
728 range="$sha1_src...$sha1_dst"
729 elif test $mod_src = 160000
730 then
731 range=$sha1_src
732 else
733 range=$sha1_dst
735 GIT_DIR="$name/.git" \
736 git rev-list --first-parent $range -- | wc -l
738 total_commits=" ($(($total_commits + 0)))"
740 esac
742 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
743 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
744 if test $status = T
745 then
746 if test $mod_dst = 160000
747 then
748 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
749 else
750 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
752 else
753 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
755 if test -n "$errmsg"
756 then
757 # Don't give error msg for modification whose dst is not submodule
758 # i.e. deleted or changed to blob
759 test $mod_dst = 160000 && echo "$errmsg"
760 else
761 if test $mod_src = 160000 -a $mod_dst = 160000
762 then
763 limit=
764 test $summary_limit -gt 0 && limit="-$summary_limit"
765 GIT_DIR="$name/.git" \
766 git log $limit --pretty='format: %m %s' \
767 --first-parent $sha1_src...$sha1_dst
768 elif test $mod_dst = 160000
769 then
770 GIT_DIR="$name/.git" \
771 git log --pretty='format: > %s' -1 $sha1_dst
772 else
773 GIT_DIR="$name/.git" \
774 git log --pretty='format: < %s' -1 $sha1_src
776 echo
778 echo
779 done |
780 if test -n "$for_status"; then
781 if [ -n "$files" ]; then
782 echo "# Submodules changed but not updated:"
783 else
784 echo "# Submodule changes to be committed:"
786 echo "#"
787 sed -e 's|^|# |' -e 's|^# $|#|'
788 else
793 # List all submodules, prefixed with:
794 # - submodule not initialized
795 # + different revision checked out
797 # If --cached was specified the revision in the index will be printed
798 # instead of the currently checked out revision.
800 # $@ = requested paths (default to all)
802 cmd_status()
804 # parse $args after "submodule ... status".
805 orig_flags=
806 while test $# -ne 0
808 case "$1" in
809 -q|--quiet)
810 GIT_QUIET=1
812 --cached)
813 cached=1
815 --recursive)
816 recursive=1
819 shift
820 break
823 usage
826 break
828 esac
829 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
830 shift
831 done
833 module_list "$@" |
834 while read mode sha1 stage path
836 name=$(module_name "$path") || exit
837 url=$(git config submodule."$name".url)
838 displaypath="$prefix$path"
839 if test "$stage" = U
840 then
841 say "U$sha1 $displaypath"
842 continue
844 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
845 then
846 say "-$sha1 $displaypath"
847 continue;
849 set_name_rev "$path" "$sha1"
850 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
851 then
852 say " $sha1 $displaypath$revname"
853 else
854 if test -z "$cached"
855 then
856 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
857 set_name_rev "$path" "$sha1"
859 say "+$sha1 $displaypath$revname"
862 if test -n "$recursive"
863 then
865 prefix="$displaypath/"
866 clear_local_git_env
867 cd "$path" &&
868 eval cmd_status "$orig_args"
869 ) ||
870 die "Failed to recurse into submodule path '$path'"
872 done
875 # Sync remote urls for submodules
876 # This makes the value for remote.$remote.url match the value
877 # specified in .gitmodules.
879 cmd_sync()
881 while test $# -ne 0
883 case "$1" in
884 -q|--quiet)
885 GIT_QUIET=1
886 shift
889 shift
890 break
893 usage
896 break
898 esac
899 done
900 cd_to_toplevel
901 module_list "$@" |
902 while read mode sha1 stage path
904 name=$(module_name "$path")
905 url=$(git config -f .gitmodules --get submodule."$name".url)
907 # Possibly a url relative to parent
908 case "$url" in
909 ./*|../*)
910 url=$(resolve_relative_url "$url") || exit
912 esac
914 say "Synchronizing submodule url for '$name'"
915 git config submodule."$name".url "$url"
917 if test -e "$path"/.git
918 then
920 clear_local_git_env
921 cd "$path"
922 remote=$(get_default_remote)
923 git config remote."$remote".url "$url"
926 done
929 # This loop parses the command line arguments to find the
930 # subcommand name to dispatch. Parsing of the subcommand specific
931 # options are primarily done by the subcommand implementations.
932 # Subcommand specific options such as --branch and --cached are
933 # parsed here as well, for backward compatibility.
935 while test $# != 0 && test -z "$command"
937 case "$1" in
938 add | foreach | init | update | status | summary | sync)
939 command=$1
941 -q|--quiet)
942 GIT_QUIET=1
944 -b|--branch)
945 case "$2" in
947 usage
949 esac
950 branch="$2"; shift
952 --cached)
953 cached="$1"
956 break
959 usage
962 break
964 esac
965 shift
966 done
968 # No command word defaults to "status"
969 test -n "$command" || command=status
971 # "-b branch" is accepted only by "add"
972 if test -n "$branch" && test "$command" != add
973 then
974 usage
977 # "--cached" is accepted only by "status" and "summary"
978 if test -n "$cached" && test "$command" != status -a "$command" != summary
979 then
980 usage
983 "cmd_$command" "$@"